<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.labenv");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
	%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>
	<script language="JavaScript" src="boxplot.js" type="text/javascript" charset="UTF-8"></script>
		
		
	<script language="JavaScript">
	var currentStep = 1;
	var debug = false;
	
	window.onload = function()
	{
		// Create lab environment alarms web page from configuration data
		createLabEnvAlarmWebPage();
	};

	function createLabEnvAlarmWebPage()
	{
		document.getElementById("gosetalarmblocker").style.display = 'block';
		// Get lab sensor configurations dynamically from server data
		var frm = document.forms['labenv'];
		var anyAlarmPermission = false;
		var labSensorConfigList = getLabSensorConfigList();
		if (labSensorConfigList != null)
		{
			var alarmTable = document.getElementById('alarmTableId');
			alarmTable.setAttribute('id', 'alarmTable');
			// Print alarm table header row
			var colspan = 11;
			var alarmTableHeaderClass = 'alarmtableheader';
			var alarmHeaderCell01 = getTableCellElement('Alarm', alarmTableHeaderClass);
			var alarmHeaderCell02 = getTableCellElement('Sensor', alarmTableHeaderClass);
			var alarmHeaderCell03 = getTableCellElement('Start', alarmTableHeaderClass);
			var alarmHeaderCell04 = getTableCellElement('End', alarmTableHeaderClass);
			var alarmHeaderCell05 = getTableCellElement('Weekday', alarmTableHeaderClass);
			var alarmHeaderCell06 = getTableCellElement('Temp.', alarmTableHeaderClass);
			var alarmHeaderCell07 = getTableCellElement('Temp.', alarmTableHeaderClass);
			var alarmHeaderCell08 = getTableCellElement('Humidity', alarmTableHeaderClass);
			var alarmHeaderCell09 = getTableCellElement('Humidity', alarmTableHeaderClass);
			var alarmHeaderCell10 = getTableCellElement('Alarm', alarmTableHeaderClass);
			var alarmHeaderCell11 = getTableCellElement('Alarm', alarmTableHeaderClass);
			var alarmHeaderRow = document.createElement('tr');
			alarmHeaderRow.appendChild(alarmHeaderCell01);			
			alarmHeaderRow.appendChild(alarmHeaderCell02);			
			alarmHeaderRow.appendChild(alarmHeaderCell03);			
			alarmHeaderRow.appendChild(alarmHeaderCell04);			
			alarmHeaderRow.appendChild(alarmHeaderCell05);
			alarmHeaderRow.appendChild(alarmHeaderCell06);			
			alarmHeaderRow.appendChild(alarmHeaderCell07);			
			alarmHeaderRow.appendChild(alarmHeaderCell08);			
			alarmHeaderRow.appendChild(alarmHeaderCell09);			
			alarmHeaderRow.appendChild(alarmHeaderCell10);			
			alarmHeaderRow.appendChild(alarmHeaderCell11);			
			alarmTable.appendChild(alarmHeaderRow);
			var alarmTableSubHeaderClass = 'reportsubheader';
			var alarmTableSubHeaderClass = 'alarmtableheader';
			var alarmSubHeaderCell01 = getTableCellElement('no', alarmTableSubHeaderClass);
			var alarmSubHeaderCell02 = getTableCellElement('name', alarmTableSubHeaderClass);
			var alarmSubHeaderCell03 = getTableCellElement('time', alarmTableSubHeaderClass);
			var alarmSubHeaderCell04 = getTableCellElement('time', alarmTableSubHeaderClass);
			var alarmSubHeaderCell05 = getTableCellElement('filter', alarmTableSubHeaderClass);
			var alarmSubHeaderCell06 = getTableCellElement('min', alarmTableSubHeaderClass);
			var alarmSubHeaderCell07 = getTableCellElement('max', alarmTableSubHeaderClass);
			var alarmSubHeaderCell08 = getTableCellElement('min', alarmTableSubHeaderClass);
			var alarmSubHeaderCell09 = getTableCellElement('max', alarmTableSubHeaderClass);
			var alarmSubHeaderCell10 = getTableCellElement('blocked', alarmTableSubHeaderClass);
			var alarmSubHeaderCell11 = getTableCellElement('text', alarmTableSubHeaderClass);
			var alarmSubHeaderRow = document.createElement('tr');
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell01);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell02);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell03);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell04);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell05);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell06);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell07);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell08);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell09);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell10);
			alarmSubHeaderRow.appendChild(alarmSubHeaderCell11);
			alarmTable.appendChild(alarmSubHeaderRow);
			for (var i=0; i < labSensorConfigList.length; i++)
			{
				// Get URL and name for lab sensor number 'i'
				var labSensorConfig = labSensorConfigList[i];
				var sensorUrl = labSensorConfig['url'];
				var sensorName = labSensorConfig['name'];
				//alert("i = " + i + " sensorUrl = " + sensorUrl + " sensorName = " + sensorName);
				var alarmList = labSensorConfig['alarmList'];
				//alert("i = " + i + " alarmList = " + alarmList);
				if (alarmList != null)
				{
					//alert("i = " + i + " alarmList.length = " + alarmList.length);
					for (var j=0; j < alarmList.length; j++)
					{
						// Get alarm number 'j'
						var alarm = alarmList[j];
						var alarmNo = alarm['no'];
						var startTime = alarm['startTime'];
						var endTime = alarm['endTime'];
						var weekdayFilter = alarm['weekdayFilter'];
						var temperatureMin = alarm['temperatureMin'];
						var temperatureMax = alarm['temperatureMax'];
						var humidityMin = alarm['humidityMin'];
						var humidityMax = alarm['humidityMax'];
						var alarmBlocked = alarm['alarmBlocked'];
						var alarmText = alarm['alarmText'];
						var alarmPermission = alarm['alarmPermission'];
						if (alarmPermission != null && alarmPermission)
						{
							anyAlarmPermission = true;
						}
						if (alarmBlocked == null)
						{
							alarmBlocked = false;
						}
						if (alarmText == null)
						{
							alarmText = '-';
						}
						//alert("createLabEnvAlarmWebPage(): i = " + i + " j = " + j + " sensorName = " + sensorName + " startTime = " + startTime  + " endTime = " + endTime + " weekdayFilter = " + weekdayFilter + " temperatureMin = " + temperatureMin + " temperatureMax = " + temperatureMax + " humidityMin = " + humidityMin + " humidityMax = " + humidityMax + " alarmBlocked = " + alarmBlocked + " alarmText = " + alarmText);
						var alarmRowText = alarmNo + '\n' + sensorName + '\n' + startTime + '\n'  + endTime + '\n' + weekdayFilter + '\n' + temperatureMin + '\n' + temperatureMax + '\n' + humidityMin + '\n' + humidityMax + '\n' + alarmBlocked + '\n' + alarmText;
						//alert("alarmRowText = " + alarmRowText);
						var alarmRow = document.createElement('tr');
						//var alarmTableClass = 'reportheader';
						var alarmTableClass = 'reportdata';
						var alarmCell01 = getTableCellElement(alarmNo, alarmTableClass);
						var alarmCell02 = getTableCellElement(sensorName, alarmTableClass);
						var alarmCell03 = getTableCellElement(startTime, alarmTableClass);
						var alarmCell04 = getTableCellElement(endTime, alarmTableClass);
						var alarmCell05 = getTableCellElement(weekdayFilter, alarmTableClass);
						var alarmCell06 = getTableCellElement(temperatureMin, alarmTableClass);
						var alarmCell07 = getTableCellElement(temperatureMax, alarmTableClass);
						var alarmCell08 = getTableCellElement(humidityMin, alarmTableClass);
						var alarmCell09 = getTableCellElement(humidityMax, alarmTableClass);
						var alarmCell10 = getTableCellYesNoSelectElement(alarmBlocked, 'alarmBlockedId' + alarmNo, alarmPermission, alarmTableClass);
						var alarmCell11 = getTableCellElement(alarmText, alarmTableClass);
						alarmRow.appendChild(alarmCell01);
						alarmRow.appendChild(alarmCell02);
						alarmRow.appendChild(alarmCell03);
						alarmRow.appendChild(alarmCell04);
						alarmRow.appendChild(alarmCell05);
						alarmRow.appendChild(alarmCell06);
						alarmRow.appendChild(alarmCell07);
						alarmRow.appendChild(alarmCell08);
						alarmRow.appendChild(alarmCell09);
						alarmRow.appendChild(alarmCell10);
						alarmRow.appendChild(alarmCell11);
						alarmTable.appendChild(alarmRow);
					}
				}
			}
		}
		if (!anyAlarmPermission)
		{
			// Hide "Set alarm blocker" button if logged-in user does not have permission to set any alarm blocker status
			document.getElementById("gosetalarmblocker").style.display = 'none';
		}
	}

	function getLabSensorConfigList()
	{
		// Get lab sensor configurations JSON object with AJAX
		var frm = document.forms['labenv'];
		var request = Ajax.getXmlHttpRequest();
		var url = '../../labenv.jar/LabEnvironment.servlet?ID=<%=ID%>&cmd=GetLabSensorConfigList';
		request.open("GET", url, false); 
		request.send(null);
	
		//if (debug) Main.debug(request.responseText);
		//Main.debug(request.responseText);

		var response = JSON.parse(request.responseText);
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
	
		// Get sensor configurations information from the AJAX response
		var labSensorConfigList = response.labSensorConfigList;

		return labSensorConfigList;
	}

	function goSetAlarmBlocker()
	{
		// Set alarm blocked flags with AJAX
		var request = Ajax.getXmlHttpRequest();
		var url = '../LabEnvironment.servlet?ID=<%=ID%>&cmd=SetLabEnvAlarmConfig';		
		// Get alarm blocker status from form option menus
		var frm = document.forms['labenv'];
		var labSensorConfigList = getLabSensorConfigList();
		if (labSensorConfigList != null)
		{
			for (var i=0; i < labSensorConfigList.length; i++)
			{
				// Get URL and name for lab sensor number 'i'
				var labSensorConfig = labSensorConfigList[i];
				var alarmList = labSensorConfig['alarmList'];
				//alert("i = " + i + " alarmList = " + alarmList);
				if (alarmList != null)
				{
					//alert("i = " + i + " alarmList.length = " + alarmList.length);
					for (var j=0; j < alarmList.length; j++)
					{
						// Get alarm number 'j'
						var alarm = alarmList[j];
						var alarmNo = alarm['no'];
						// Get value for alarm blocker option menu
						var alarmBlockedMenuId = 'alarmBlockedId' + alarmNo;
						var selectEl = document.getElementById(alarmBlockedMenuId);
						//alert("alarmNo = " + alarmNo + " alarmBlockedMenuId = " + alarmBlockedMenuId + " selectEl = " + selectEl);
						if (selectEl != null)
						{
							var selectValue = selectEl.value;
							//alert("alarmNo = " + alarmNo + " alarmBlockedMenuId = " + alarmBlockedMenuId + " value = " + selectValue);
							if (selectValue == null)
							{
								selectValue = false;
							}
							// Add alarm block value to Ajax URL
							url += '&' + alarmBlockedMenuId + '=' + selectValue;
						}
					}
				}
			}
		}
		request.open("GET", url, false); 
		request.send(null);
	
		if (debug) Main.debug(request.responseText);

		var response = JSON.parse(request.responseText);
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
	}

	function getJSONData(jsonObject, key)
	{
		var data = getJSONData(jsonObject, key, '');
		return data;
	}

	function getJSONData(jsonObject, key, defaultChoice)
	{
		var data = defaultChoice;
		if (jsonObject != null)
		{
			if (jsonObject[key] != null)
			{
				data = jsonObject[key];
			}
		}
		return data;
	}

	function getTableCellElement(text, clazz, colspan, rowspan)
	{
		var cellElement = document.createElement('td');
		text = new String(text);		
		var textArray = text.split("\n");		
		if (textArray.length > 1)
		{	
			for (var i=0;i<textArray.length;i++)
			{				
				if (i>0)cellElement.appendChild(document.createElement('br'));
				cellElement.appendChild(document.createTextNode(textArray[i]));
			}			
		}
		else
		{
			cellElement.appendChild(document.createTextNode(text));
		}
		cellElement.setAttribute('class', clazz);
		if (colspan != null) cellElement.setAttribute('colspan', colspan);
		if (rowspan != null) cellElement.setAttribute('rowspan', rowspan);
		
		return cellElement;
	}

	function getTableCellYesNoSelectElement(value, id, permission, clazz, colspan, rowspan)
	{
		/*
		<td class="input">
			<select id="yesNoSelectId">
				<option value="true">Yes</option>
				<option value="false" selected="yes">No</option>
			</select>
		</td>
		*/
		var cellElement = document.createElement('td');
		var selectElement = document.createElement('select');
		selectElement.setAttribute('id', id);
		selectElement.setAttribute('name', id);
		if (permission == null || !permission)
		{
			selectElement.setAttribute('disabled', true);
		}
		// Create and add new option elements to select menu
		var optionYesEl = document.createElement('option');
		optionYesEl.setAttribute('value', true);
		optionYesEl.innerHTML = 'Yes';
		if (value != null && value)
		{
			optionYesEl.setAttribute('selected','yes');
		}
		var optionNoEl = document.createElement('option');
		optionNoEl.setAttribute('value', false);
		optionNoEl.innerHTML = 'No';
		if (value == null || !value)
		{
			optionNoEl.setAttribute('selected','yes');
		}
		selectElement.appendChild(optionYesEl);
		selectElement.appendChild(optionNoEl);
		cellElement.appendChild(selectElement);
		cellElement.setAttribute('class', 'input');
		cellElement.setAttribute('align', 'center');
		cellElement.setAttribute('text-align', 'center');
		cellElement.setAttribute('class', clazz);
		if (colspan != null) cellElement.setAttribute('colspan', colspan);
		if (rowspan != null) cellElement.setAttribute('rowspan', rowspan);
		
		return cellElement;
	}

	function goPrint()
	{
		var printNote = '<b>Note!</b> For better printing set page orientation to <i>portrait</i>.';
		printNote += ' Scale down to <i>90%</i> to fit 2 plots per page.';
		openPrintWindow('<%=ID%>', 'reportcell', 'Lab environment statistics', 'portrait', printNote, '../');
	}
	</script>
	
	<style>
	.alarmtableheader
	{	
		text-align: center;
		vertical-align: bottom;
		background: #E0E0E0;
		cellspacing: 0;
		cellpadding: 0;	
	}
	</style>
	</base:head>
	<base:body onload="init()">
		<p:path><p:pathelement 
			title="LabEnv" href="<%="./labenvironmentalarms.jsp?ID="+ID%>" 
			/><p:pathelement title="Lab environment alarms" 
			/></p:path>
		<div id="x-guide" style="position: absolute; z-index: 99; display: none; background-color: #224488; width: 1px;"></div>
		<div id="y-guide" style="position: absolute; z-index: 99; display: none; background-color: #224488; height: 1px;"></div>
		<div class="content">
	
		<form name="labenv" onsubmit="return false;">
			<!-- 1. Report type-->
			<table border="0" cellspacing="0" cellpadding="0" class="stepform">
			<tr>
				<td rowspan="3" class="stepno">1</td>
				<td class="steptitle">Alarms</td>
			</tr>
			<tr>
				<td class="stepfields">
					<table id="alarmTableId" border="0" cellspacing="0" cellpadding="0" width="100%">
					</table>
				</td>
			</tr>
			</table>
			
			<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>		
				
			<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
				<tr>
					<td><base:button id="gosetalarmblocker" title="Set alarm blocker" image="<%="gonext.png"%>" onclick="goSetAlarmBlocker()" /></td>
				</tr>
			</table>			
		</form>
		</div>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>